$fn = 100; /* number of facets per circle */

/*
	_h = height
	_w = width
	_r = radius
	_g = gap
	_t = tolerance
	_s = scaling factor (printer specific)
*/

dim_s = 1;
dim_s = 1.015; /* makerbot */
sv = [dim_s, dim_s, dim_s];

epaisseur = 1.5;
rayon = 15;
largeur = 90;
profondeur = 45;

module faceArriere()
{
	//Parties rondes
	cylinder(r=rayon-epaisseur/2, h=epaisseur);

	translate([0,0,largeur-epaisseur]) 
		cylinder(r=rayon-(epaisseur/2), h=epaisseur);

	difference() {
		//Prolongations plates après parties rondes
		translate([0,-rayon+(epaisseur/2),0]) difference() {
			cube([profondeur,2*rayon-epaisseur,largeur], center=false);
			translate([0,0,epaisseur]) 
				cube([profondeur,2*rayon-epaisseur,largeur-epaisseur*2], center=false);
		}

//!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!
		//Trou pour alimentation
		translate([profondeur-5-5,-rayon+19,largeur-7]) cylinder(r=3, h=8);
		//Trou pour connecteurs LED strip
		translate([profondeur-15-7-5,-rayon+17,-5]) cube([15,6,10], center=false);
//!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!!!!!FIXIT!!!!
	}

	//Partie plate du fond
	translate([profondeur-epaisseur,-rayon+(epaisseur/2),0]) 
		cube([epaisseur,2*rayon-epaisseur,largeur], center=false);

}

module faceAvant()
{
	//Partie plate
	translate([0,-rayon,0]) {

		difference() {

			difference() {
				cube([profondeur,2*rayon,largeur], center=false);
				translate([0,epaisseur/2,0]) cube([profondeur,2*rayon-epaisseur,largeur], center=false);
			}
			//Bouton 1
			rotate(a=[90, 0, 0]) translate([profondeur-37.5,largeur-11.5,-3]) cylinder(r=2.5, h=8);
			//Bouton 2
			rotate(a=[90, 0, 0]) translate([profondeur-37.5,largeur-19,-3]) cylinder(r=2.5, h=8);
			//Bouton 3
			rotate(a=[90, 0, 0]) translate([profondeur-37.5,largeur-26.5,-3]) cylinder(r=2.5, h=8);
			//LED d'alarme
			rotate(a=[90, 0, 0]) translate([profondeur-35,largeur-74,-3]) cylinder(r=1.5, h=8);
			//Ouverture gauche pour l'afficheur 7-Segments
			rotate(a=[90, 90, 0]) translate([-largeur+25,profondeur-15,-4]) cube([2,15,8], center=false);
			//Ouverture droite pour l'afficheur 7-Segments
			rotate(a=[90, 90, 0]) translate([-largeur+63.5,profondeur-35,-4]) cube([2,35,8], center=false);
		}
	}

	//Partie ronde
	difference() {
		cylinder(r=rayon, h=largeur);
		cylinder(r=rayon-(epaisseur/2), h=largeur);
		translate([0,-rayon,0]) cube([profondeur,2*rayon,largeur], center=false);
	}

}

scale(sv) {
	//translate([-70,0,0])
 	rotate(a=[0, 90, 0]) translate([-profondeur,0,0])
		faceArriere();

	//translate([-70,0,0])
	//	faceAvant();
}
