void executeAlarm(void);

#define BEEP_PIN 9

bool h12;
bool PM;
bool Century=false;
bool ADy, A12h, Apm;
bool doWaitingEndOfMinute = false;
extern DS3231 Clock;

extern byte B1cnt;
extern byte B2cnt;
extern byte B3cnt;
byte LED1cnt = 0;
int  LED1inc = 1;
byte LED1max = 255;
byte LED2cnt = 10;
byte LED3cnt;
byte LED3bright=255;

void setup_alarm(void) {
}

void checkBeepNow(void){
  if (forceAlarmManually){
    doAlarm = true;
    return;
  }
  if (Clock.checkAlarmEnabled(1)) {
    Clock.getA1Time(ADay, AHour, AMinute, ASecond, ABits, ADy, A12h, Apm);
    if (h==AHour && m==AMinute && s==ASecond) {
      //Serial.print("ALARM!!!\n");
      pinMode(BEEP_PIN,OUTPUT);
      doAlarm = true;
      doWaitingEndOfMinute = true;
    }
  } 
  else {
    doAlarm = false;
    doWaitingEndOfMinute=false;
    digitalWrite(BEEP_PIN,LOW);
    strip.setPixelColor(0, strip.Color(0,0,0)); 
    strip.setPixelColor(1, strip.Color(0,0,0)); 
    strip.setPixelColor(2, strip.Color(0,0,0));
    strip.show();
  }

  if (doWaitingEndOfMinute && alarmType != LED3){ //Limit alarm producing tone beep for 1 minute. This does not apply for LED3 alarm type which does not produce any sound.
    if (h==AHour && m!=AMinute){
      doAlarm = false;
      digitalWrite(BEEP_PIN,LOW);
      for(unsigned int i=0;i<strip.numPixels();i++){
          strip.setPixelColor(i, strip.Color(0,0,0)); 
      }
      strip.show();
    }
  }
}

////////////////////////////////////////////////////////////////////////////////////ANALOG BEEP
byte names_count = 9;
byte notes_count;
int count = 0;
byte *melody;
byte duration = 30;

byte names[] = {'K', 'c', 'd', 'e', 'f', 'g', 'a', 'b', 'C'};
int tones[] = {2080, 1915, 1700, 1519, 1432, 1275, 1136, 1014, 956};

byte melody3[] = "2d 2a 1f 2c 2d 2a 2d 2c 2f 2d 2a 2c 2d 2a 1f 2c 2d 2a 2a 2g 2p 8p 8p 8p ";
byte melody2[] = "1d ";
byte melody1[] = "1g 2c 1c 2K 1c 4d 1p 1e 2f 1e 2d 1e 4c 1p 1g 2c 1c 2K 1c 3d 2p 1e 2f 1e 2d 1e 2c 1p 2e 1f 3g 1p 2g 1a 3g 1p 2f 1e 2d 1c 2K 1c 2d 1p 2e 1f 3g 1p 2g 1a 3g 1p 1C 1b 1a 1g 1a 1g 1f 1e 1d 2c 4p "; //Doudou
// count length:  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  
//                                          10                            20                            30                            40                            50                            60                            70
void analogBeep(){ 

  if (alarmType == BEEP){
    melody = melody1; notes_count = strlen((char*)melody1)/3; duration = 30;
  } else {
    melody = melody2; notes_count = strlen((char*)melody2)/3; duration = 15;
  }
  
  for (int count3 = 0; count3 <= (melody[count*3] - 48) * duration; count3++) {
    for (int count2=0;count2< names_count; count2++) { //Recherche de la note dans la gamme.
      if (names[count2] == melody[count*3 + 1]) {    
        analogWrite(BEEP_PIN,500);
        delayMicroseconds(tones[count2]);
        analogWrite(BEEP_PIN, 0);
        delayMicroseconds(tones[count2]);
      } 
      if (melody[count*3 + 1] == 'p') {
        // make a pause of a certain size
        analogWrite(BEEP_PIN, 0);
        delayMicroseconds(500);
      }
      if (!digitalRead(B1_PIN)) B1cnt+=1;
      if (!digitalRead(B2_PIN)) B2cnt+=1;
      if (!digitalRead(B3_PIN)) B3cnt+=1;
    }
  }
  
  count += 1; if (count > notes_count) count = 0;

}

//////////////////////////////////////////////////////////////////////////////////////DIGITAL BEEP
int length = 15; // the number of notes
char notes[] = "ccggaagffeeddc "; // a space represents a rest
int beats[] = { 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 2, 4 };
int tempo = 300;

void playTone(int tone, int duration) {
  for (long i = 0; i < duration * 1000L; i += tone * 2) {
    digitalWrite(BEEP_PIN, HIGH);
    delayMicroseconds(tone);
    digitalWrite(BEEP_PIN, LOW);
    delayMicroseconds(tone);
  }
  
  if (!digitalRead(B1_PIN)) B1cnt+=1;
  if (!digitalRead(B2_PIN)) B2cnt+=1;
  if (!digitalRead(B3_PIN)) B3cnt+=1;
}

void playNote(char note, int duration) {
  char names[] = { 'c', 'd', 'e', 'f', 'g', 'a', 'b', 'C' };
  int tones[] = { 1915, 1700, 1519, 1432, 1275, 1136, 1014, 956 };

  for (int i = 0; i < 8; i++) {
    if (names[i] == note) {
      playTone(tones[i], duration);
    }
  }
}

void digitalBeep() {
  count += 1; if (count > length) count = 0;

  if (notes[count] == ' ') {
    delay(beats[count] * tempo); // rest
  } else {
    playNote(notes[count], beats[count] * tempo);
  }
  
  // pause between notes
  delay(tempo / 2); 
}
///////////////////////////////////////////////

void executeAlarm(void){
  if (doAlarm == false) {
    //analogWrite(BEEP_PIN, 0);
    //digitalWrite(BEEP_PIN, LOW);
    count = 0;
  }
  
  if (doAlarm == true && alarmType == BEEP){//=======================
    forceShutdownDisplayAndAlarmLed = false;
    analogBeep();
    //digitalBeep();
  }
  
  if (doAlarm == true && alarmType == LED1){//=======================
 
    if (!forceAlarmManually) analogBeep();
 
    forceShutdownDisplayAndAlarmLed = false;   
    LED1cnt += LED1inc;
    if (LED1cnt >= LED1max) LED1inc = -LED1inc;
    if (LED1cnt <= 0)   LED1inc = -LED1inc;
    strip.setBrightness(LED1cnt);
    if (LED1cnt == 0){
      cr=TrueRandom.random(0,255);cg=TrueRandom.random(0,255);cb=TrueRandom.random(0,255);
    }

    for(unsigned int i=0;i<strip.numPixels();i++){
      strip.setPixelColor(i, strip.Color(cg,cr,cb)); 
    }
    strip.show();
  }
  
  if (doAlarm == true && alarmType == LED2){//=======================
    uint16_t i;
    
    if (!forceAlarmManually) analogBeep();

    forceShutdownDisplayAndAlarmLed = false;
    wheelcycleIdx += 1;
    if (wheelcycleIdx==256) wheelcycleIdx=0;
    
    //if (!forceAlarmManually){ 
      strip.setBrightness(LED2cnt);
      for(i=0; i<strip.numPixels(); i++) { strip.setPixelColor(i, Wheel(((i * 256 / (strip.numPixels())) + wheelcycleIdx) & 255)); }
      strip.show();
    //}
    
  }
  
  if (doAlarm == true && alarmType == LED3){//=======================
 
//    if (!forceAlarmManually) analogBeep();

    strip.setBrightness(LED3bright);
    forceShutdownDisplayAndAlarmLed = false;

    if (LED3cnt-- <= 0){
      LED3cnt = LED3bright;
      cr0=TrueRandom.random(0,255); cg0=TrueRandom.random(0,255); cb0=TrueRandom.random(0,255);
    }
    
    if (cr0 < cr) cr--; if (cr0 > cr) cr++;
    if (cg0 < cg) cg--; if (cg0 > cg) cg++;
    if (cb0 < cb) cb--; if (cb0 > cb) cb++;

    for(unsigned int i=0;i<strip.numPixels();i++){
      strip.setPixelColor(i, strip.Color(cg,cr,cb)); 
    }
    strip.show();
  }
}
