#include <Adafruit_NeoPixel.h>


void setup_ledstrip(void);
uint32_t Wheel(byte WheelPos);

#define LEDSTRIP_PIN 8
#define LEDSTRIP_NUMLED 30

Adafruit_NeoPixel strip = Adafruit_NeoPixel(LEDSTRIP_NUMLED, LEDSTRIP_PIN, NEO_GRB + NEO_KHZ800);

void setup_ledstrip(void){
  pinMode(LEDSTRIP_PIN, OUTPUT);
  strip.begin();
  strip.show();
  strip.setBrightness(20);
}

void rainbowCycle() {
  uint16_t i, j;

  for(j=0; j<256; j++) {   
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(30);
  }
}

uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } 
  else if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  } 
  else {
    WheelPos -= 170;
    return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}


