#include <DS3231.h>
#include <Wire.h>

void setup_rtc(void);
void do_rtc(void);

void checkBeepNow(void);
extern void rainbowCycle(void);
void writeToEeprom(unsigned int addr, byte value);
byte readFromEeprom(unsigned int addr, byte defaultValue);

bool doBeep = true;
bool doAlarm = false;
int pinbeepValue=1;
DS3231 Clock;

byte s,m,h,dd,mm,yy,T; 
byte ADay, AHour, AMinute, ASecond, ABits;
bool forceAlarmManually = false;

void setup_rtc(void) {
  // Start the I2C interface
  Wire.begin();
  Clock.enableOscillator(true,false,0);

  pinMode(B1_PIN,INPUT_PULLUP);
  pinMode(B2_PIN,INPUT_PULLUP);
  pinMode(B3_PIN,INPUT_PULLUP);

  pinMode(PIN_ALRMLED, OUTPUT);

  Serial.begin(115200);
}

void ReadDS3231()
{
  s=Clock.getSecond();
  m=Clock.getMinute();
  h=Clock.getHour(h12, PM);
  dd=Clock.getDate();
  mm=Clock.getMonth(Century);
  yy=Clock.getYear();
  T=Clock.getTemperature();
}
void do_rtc() {
  ReadDS3231();
}

void i2c_eeprom_write_byte( int deviceaddress, unsigned int eeaddress, byte data ) {
  int rdata = data;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.write(rdata);
  Wire.endTransmission();
}

byte i2c_eeprom_read_byte( int deviceaddress, unsigned int eeaddress ) {
  byte rdata = 0xFF;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.endTransmission();
  Wire.requestFrom(deviceaddress,1);
  if (Wire.available()) rdata = Wire.read();
  return rdata;
}
  
void writeToEeprom(unsigned int addr, byte value){
  i2c_eeprom_write_byte(0x57, addr, value);
}

byte readFromEeprom(unsigned int addr, byte defaultValue){
  byte val;
  
  val = i2c_eeprom_read_byte(0x57, addr);
  if (val == 0) val = defaultValue;
  
  return val;
}

